## open-iscsi 2.0.873+git0.3b4b4500

=== Makefile ===
#
# Makefile for the Open-iSCSI Initiator
#

# if you are packaging open-iscsi, set this variable to the location
# that you want everything installed into.
DESTDIR ?= 

prefix = /usr
exec_prefix = /
sbindir = $(exec_prefix)/sbin
bindir = $(exec_prefix)/bin
mandir = $(prefix)/share/man
etcdir = /etc
initddir = $(etcdir)/init.d

MANPAGES = doc/iscsid.8 doc/iscsiadm.8 doc/iscsi_discovery.8 iscsiuio/docs/iscsiuio.8
PROGRAMS = usr/iscsid usr/iscsiadm utils/iscsi_discovery utils/iscsi-iname iscsiuio/src/unix/iscsiuio
INSTALL = install
ETCFILES = etc/iscsid.conf
IFACEFILES = etc/iface.example

# Random comments:
# using '$(MAKE)' instead of just 'make' allows make to run in parallel
# over multiple makefile.

all: user

user: utils/open-isns/Makefile iscsiuio/Makefile
	$(MAKE) -C utils/open-isns
	$(MAKE) -C utils/sysdeps
	$(MAKE) -C utils/fwparam_ibft
	$(MAKE) -C usr
	$(MAKE) -C utils
	$(MAKE) -C iscsiuio
	@echo
	@echo "Compilation complete                 Output file"
	@echo "-----------------------------------  ----------------"
	@echo "Built iSCSI daemon:                  usr/iscsid"
	@echo "Built management application:        usr/iscsiadm"
	@echo "Built boot tool:                     usr/iscsistart"
	@echo "Built iscsiuio daemon:               iscsiuio/src/unix/iscsiuio"
	@echo
	@echo "Read README file for detailed information."

utils/open-isns/Makefile: utils/open-isns/configure utils/open-isns/Makefile.in
	cd utils/open-isns; ./configure CFLAGS="$(OPTFLAGS)" --with-security=no

iscsiuio/Makefile: iscsiuio/configure iscsiuio/Makefile.in
	cd iscsiuio; ./configure

kernel: force
	$(MAKE) -C kernel
	@echo "Kernel Compilation complete          Output file"
	@echo "-----------------------------------  ----------------"
	@echo "Built iSCSI Open Interface module:   kernel/scsi_transport_iscsi.ko"
	@echo "Built iSCSI library module:          kernel/libiscsi.ko"
	@echo "Built iSCSI over TCP library module: kernel/libiscsi_tcp.ko"
	@echo "Built iSCSI over TCP kernel module:  kernel/iscsi_tcp.ko"

force: ;

clean:
	$(MAKE) -C utils/sysdeps clean
	$(MAKE) -C utils/fwparam_ibft clean
	$(MAKE) -C utils clean
	$(MAKE) -C usr clean
	$(MAKE) -C kernel clean
	$(MAKE) -C iscsiuio clean
	$(MAKE) -C utils/open-isns clean
	$(MAKE) -C utils/open-isns distclean

# this is for safety
# now -jXXX will still be safe
# note that make may still execute the blocks in parallel
.NOTPARALLEL: install_user install_programs install_initd \
	install_initd_suse install_initd_redhat install_initd_debian \
	install_etc install_iface install_doc install_kernel install_iname

install: install_programs install_doc install_etc \
	install_initd install_iname install_iface

install_user: install_programs install_doc install_etc \
	install_initd install_iname install_iface

install_programs:  $(PROGRAMS)
	$(INSTALL) -d $(DESTDIR)$(sbindir)
	$(INSTALL) -m 755 $^ $(DESTDIR)$(sbindir)

# ugh, auto-detection is evil
# Gentoo maintains their own init.d stuff
install_initd:
	if [ -f /etc/debian_version ]; then \
		$(MAKE) install_initd_debian ; \
	elif [ -f /etc/redhat-release ]; then \
		$(MAKE) install_initd_redhat ; \
	elif [ -f /etc/SuSE-release ]; then \
		$(MAKE) install_initd_suse ; \
	fi

# these are external targets to allow bypassing distribution detection
install_initd_suse:
	$(INSTALL) -d $(DESTDIR)$(initddir)
	$(INSTALL) -m 755 etc/initd/initd.suse \
		$(DESTDIR)$(initddir)/open-iscsi
	$(INSTALL) -m 755 etc/initd/boot.suse \
		$(DESTDIR)$(initddir)/boot.open-iscsi

install_initd_redhat:
	$(INSTALL) -d $(DESTDIR)$(initddir)
	$(INSTALL) -m 755 etc/initd/initd.redhat \
		$(DESTDIR)$(initddir)/open-iscsi

install_initd_debian:
	$(INSTALL) -d $(DESTDIR)$(initddir)
	$(INSTALL) -m 755 etc/initd/initd.debian \
		$(DESTDIR)$(initddir)/open-iscsi

install_iface: $(IFACEFILES)
	$(INSTALL) -d $(DESTDIR)$(etcdir)/iscsi/ifaces
	$(INSTALL) -m 644 $^ $(DESTDIR)$(etcdir)/iscsi/ifaces

install_etc: $(ETCFILES)
	if [ ! -f /etc/iscsi/iscsid.conf ]; then \
		$(INSTALL) -d $(DESTDIR)$(etcdir)/iscsi ; \
		$(INSTALL) -m 644 $^ $(DESTDIR)$(etcdir)/iscsi ; \
	fi

install_doc: $(MANPAGES)
	$(INSTALL) -d $(DESTDIR)$(mandir)/man8
	$(INSTALL) -m 644 $^ $(DESTDIR)$(mandir)/man8

install_kernel:
	$(MAKE) -C kernel install_kernel

install_iname:
	if [ ! -f /etc/iscsi/initiatorname.iscsi ]; then \
		echo "InitiatorName=`$(DESTDIR)/sbin/iscsi-iname`" > $(DESTDIR)/etc/iscsi/initiatorname.iscsi ; \
		echo "***************************************************" ; \
		echo "Setting InitiatorName to `cat $(DESTDIR)/etc/iscsi/initiatorname.iscsi`" ; \
		echo "To override edit /etc/iscsi/initiatorname.iscsi" ; \
		echo "***************************************************" ; \
	fi

depend:
	for dir in usr utils utils/fwparam_ibft; do \
		$(MAKE) -C $$dir $@; \
	done

# vim: ft=make tw=72 sw=4 ts=4:

=== usr/Makefile ===
# This Makefile will work only with GNU make.

OSNAME=$(shell uname -s)

# allow users to override these
# eg to compile for a kernel that you aren't currently running
KERNELRELEASE ?= $(shell uname -r)
KSRC ?= /lib/modules/$(KERNELRELEASE)/build

KSUBLEVEL=$(shell cat $(KSRC)/Makefile | awk -F= '/^SUBLEVEL =/ {print $$2}' | \
			sed 's/^[ \t]*//;s/[ \t]*$$//')

ifeq ($(OSNAME),Linux)
	ifeq ($(KSUBLEVEL),11)
		IPC_CFLAGS=-DNETLINK_ISCSI=12 -D_GNU_SOURCE
	else
	ifeq ($(KSUBLEVEL),12)
		IPC_CFLAGS=-DNETLINK_ISCSI=12 -D_GNU_SOURCE
	else
		IPC_CFLAGS=-DNETLINK_ISCSI=8 -D_GNU_SOURCE
	endif
	endif
IPC_OBJ=netlink.o
else
ifeq ($(OSNAME),FreeBSD)
IPC_CFLAGS=
IPC_OBJ=ioctl.o
endif
endif

OPTFLAGS ?= -O2 -g
WARNFLAGS ?= -Wall -Wstrict-prototypes
CFLAGS += $(OPTFLAGS) $(WARNFLAGS) -I../include -I. -I../utils/open-isns \
				-D$(OSNAME) $(IPC_CFLAGS)
PROGRAMS = iscsid iscsiadm iscsistart

# libc compat files
SYSDEPS_SRCS = $(wildcard ../utils/sysdeps/*.o)
# sources shared between iscsid, iscsiadm and iscsistart
ISCSI_LIB_SRCS = iscsi_util.o io.o auth.o iscsi_timer.o login.o log.o md5.o \
	sha1.o iface.o idbm.o sysfs.o host.o session_info.o iscsi_sysfs.o \
	iscsi_net_util.o iscsid_req.o transport.o iser.o cxgbi.o be2iscsi.o \
	initiator_common.o iscsi_err.o flashnode.o uip_mgmt_ipc.o \
	$(IPC_OBJ)  $(SYSDEPS_SRCS)
# core initiator files
INITIATOR_SRCS = initiator.o scsi.o actor.o event_poll.o mgmt_ipc.o kern_err_table.o

# fw boot files
FW_BOOT_SRCS = $(wildcard ../utils/fwparam_ibft/*.o)

# core discovery files
DISCOVERY_SRCS = $(FW_BOOT_SRCS) strings.o discovery.o

all: $(PROGRAMS)

iscsid: $(ISCSI_LIB_SRCS) $(INITIATOR_SRCS) $(DISCOVERY_SRCS) \
	iscsid.o session_mgmt.o discoveryd.o
	$(CC) $(CFLAGS) $^ -o $@  -L../utils/open-isns -lisns

iscsiadm: $(ISCSI_LIB_SRCS) $(DISCOVERY_SRCS) iscsiadm.o session_mgmt.o
	$(CC) $(CFLAGS) $^ -o $@ -L../utils/open-isns -lisns

iscsistart: $(ISCSI_LIB_SRCS) $(INITIATOR_SRCS) $(FW_BOOT_SRCS) \
		iscsistart.o statics.o
	$(CC) $(CFLAGS) -static $^ -o $@
clean:
	rm -f *.o $(PROGRAMS) .depend $(LIBSYS)

depend:
	gcc $(CFLAGS) -M `ls *.c` > .depend

-include .depend

=== utils/fwparam_ibft/Makefile ===
#
#  Copyright (C) IBM Corporation. 2007
#  Author: Doug Maxey <dwm@austin.ibm.com>
#
#  This program is free software: you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation, either version 2 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
#  Authors: Patrick Mansfield <patmans@us.ibm.com>
#	    Mike Anderson <andmike@us.ibm.com>
#	    Doug Maxey <dwm@austin.ibm.com>
#	    "Prasanna Mumbai" <mumbai.prasanna@gmail.com>
#

SYSDEPS_OBJS = $(wildcard ../sysdeps/*.o)
OBJS := fw_entry.o fwparam_sysfs.o $(SYSDEPS_OBJS) ../../usr/iscsi_net_util.o
OBJS += prom_lex.o prom_parse.tab.o fwparam_ppc.o
CLEANFILES = $(OBJS) *.output *~

OPTFLAGS ?= -O2 -g -fPIC
WARNFLAGS ?= -Wall -Wstrict-prototypes
CFLAGS += $(OPTFLAGS) $(WARNFLAGS) -I../../include -I../../usr -D_GNU_SOURCE

all: $(OBJS)

clean:
	rm -f *.o $(CLEANFILES) .depend

$(OBJS): prom_parse.tab.h prom_parse.h fwparam_ibft.h

depend:
	gcc $(CFLAGS) -M `ls *.c` > .depend

-include .depend

=== debian/control ===
Source: open-iscsi
Section: net
Priority: optional
Maintainer: Debian iSCSI Maintainers <pkg-iscsi-maintainers@lists.alioth.debian.org>
Uploaders: Andrew Moise <chops@demiurgestudios.com>, Philipp Hug <debian@hug.cx>, Guido Günther <agx@sigxcpu.org>, Ritesh Raj Sarraf <rrs@debian.org>
Build-Depends: debhelper (>= 7.0.0), bzip2, bison, flex, autotools-dev, dh-autoreconf, dpkg-dev (>= 1.16.1~)
Standards-Version: 3.9.2
Vcs-Git: git://anonscm.debian.org/pkg-iscsi/open-iscsi.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-iscsi/open-iscsi.git
Homepage: http://www.open-iscsi.org/

Package: open-iscsi
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, udev
Description: High performance, transport independent iSCSI implementation
 Open-iSCSI is a high-performance, transport independent, multi-platform
 implementation of RFC3720 iSCSI
 .
 Open-iSCSI is partitioned into user and kernel parts where the kernel
 portion implements iSCSI data path (i.e. iSCSI Read and iSCSI Write)
 The userspace contains the entire control plane consisting of:
  * Configuration Manager
  * iSCSI Discovery, Login and Logout processing
  * Connection level error processing
  * Nop-In and Nop-Out handling
  * Text processing, iSNS, SLP, Radius et cetera (future)
 .
 The userspace component consists of a daemon, iscsid and a management
 utility, iscsiadm

Package: open-iscsi-udeb
Architecture: amd64 arm64 i386 ia64 mips mipsel powerpc s390x ppc64el ppc64 armhf
Section: debian-installer
Package-Type: udeb
Depends: ${shlibs:Depends}, ${misc:Depends}, scsi-modules, libnss-files-udeb
Description: Configure iSCSI
 Open-iSCSI is a high-performance, transport independent, multi-platform
 implementation of RFC3720 iSCSI.
 .
 This is the minimal package (udeb) used by debian-installer.

#Package: linux-iscsi-modules-source
#Architecture: all
#Depends: ${shlibs:Depends}, ${misc:Depends}, module-assistant, debhelper (>= 4.0.0), bzip2
#Description: Source Code for the Linux iSCSI Kernel Modules
# Along with make-kpkg, this package maybe used to build a linux-iscsi-modules 
# package for a kernel-image package.

=== debian/rules ===
#!/usr/bin/make -f
# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# This has to be exported to make some magic below work.
export DH_OPTIONS


# get-orig-source target
DEB_UPSTREAM_VERSION=$(shell dpkg-parsechangelog | sed -rne 's,^Version: ([^-]+).*,\1,p')

DEB_HOST_ARCH?=$(shell dpkg-architecture -qDEB_HOST_ARCH)
SUPPORTED_ARCH_UDEB = amd64 arm64 i386 ia64 mips mipsel powerpc

get-orig-source:
	[ ! -f $(ORIG_FILE).gz ] || rm -f $(ORIG_FILE).gz
	uscan --force-download --rename --repack --download-version=$(DEB_UPSTREAM_VERSION) --destdir=.


CFLAGS = -Wall -g
export OPTFLAGS =-DDISCOVERY_FILE=\"/var/lib/open-iscsi/discovery\" -DNODE_FILE=\"/var/lib/open-iscsi/node\"

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -O0
else
	CFLAGS += -O2
endif

# For Hardening
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk
#

configure: configure-stamp
configure-stamp:
	dh_testdir
	# Add here commands to configure the package.
	dh_autotools-dev_updateconfig
	dh_autoreconf

	touch configure-stamp


#Architecture 
build: build-arch

build-arch: build-arch-stamp
build-arch-stamp: configure-stamp 

	# Add here commands to compile the arch part of the package.
	$(MAKE) -C utils/fwparam_ibft
	$(MAKE) user
	$(MAKE) -C utils

	touch build-arch-stamp

build-indep: build-indep-stamp
build-indep-stamp: configure-stamp 

	# Add here commands to compile the indep part of the package.
	#$(MAKE) doc
	touch build-indep-stamp

clean:
	dh_testdir
	dh_testroot
	rm -f build-arch-stamp build-indep-stamp configure-stamp

	# Add here commands to clean up after the build process.
	$(MAKE) -C utils/fwparam_ibft clean
	$(MAKE) -C usr clean
	$(MAKE) -C utils clean
	rm -rf modules

	dh_autotools-dev_restoreconfig
	dh_autoreconf_clean
	dh_clean 

install: install-arch
# disabled kernel module package for now because source is already in debian stock kernelsy
install-indep:

install-arch:
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs -s

	# Add here commands to install the arch part of the package into 
	# debian/open-iscsi.
	install -m 755 usr/iscsiadm $(CURDIR)/debian/open-iscsi/usr/bin
	install -m 755 usr/iscsid $(CURDIR)/debian/open-iscsi/usr/sbin
	install -m 755 usr/iscsistart $(CURDIR)/debian/open-iscsi/usr/sbin
	install -m 755 utils/iscsi_discovery $(CURDIR)/debian/open-iscsi/usr/sbin
	install -m 755 utils/iscsi-iname $(CURDIR)/debian/open-iscsi/usr/sbin
	install -m 644 debian/initiatorname.iscsi $(CURDIR)/debian/open-iscsi/etc/iscsi/initiatorname.iscsi
	install -m 600 etc/iscsid.conf $(CURDIR)/debian/open-iscsi/etc/iscsi
	install -m 644 debian/open-iscsi.default $(CURDIR)/debian/open-iscsi/etc/default/open-iscsi
	install -m 644 debian/open-iscsi.systemd-drop-in $(CURDIR)/debian/open-iscsi/lib/systemd/system/open-iscsi.service.d/fix-systemd-deps.conf

ifneq (,$(findstring $(DEB_HOST_ARCH),$(SUPPORTED_ARCH_UDEB)))
	# udeb stuff
	install -m 755 usr/iscsiadm $(CURDIR)/debian/open-iscsi-udeb/bin
	install -m 755 utils/iscsi-iname $(CURDIR)/debian/open-iscsi-udeb/sbin
	install -m 755 utils/iscsi_discovery $(CURDIR)/debian/open-iscsi-udeb/sbin
	install -m 755 usr/iscsid $(CURDIR)/debian/open-iscsi-udeb/sbin
	install -m 755 usr/iscsistart $(CURDIR)/debian/open-iscsi-udeb/sbin
	install -m 600 etc/iscsid.conf $(CURDIR)/debian/open-iscsi-udeb/etc/iscsi
	install -m 644 debian/open-iscsi-udeb.start $(CURDIR)/debian/open-iscsi-udeb/sbin/iscsi-start
	install -m 755 debian/open-iscsi-udeb.finish-install $(CURDIR)/debian/open-iscsi-udeb/usr/lib/finish-install.d/10open-iscsi
endif

	# initramfs stuff
	install -m 755 debian/extra/initramfs.hook \
		$(CURDIR)/debian/open-iscsi/usr/share/initramfs-tools/hooks/iscsi
	install -m 755 debian/extra/initramfs.local-top \
		$(CURDIR)/debian/open-iscsi/usr/share/initramfs-tools/scripts/local-top/iscsi

	dh_install -s

# Must not depend on anything. This is to be called by
# binary-arch/binary-indep
# in another 'make' thread.
binary-common:
	dh_testdir
	dh_testroot
	dh_installchangelogs 
	dh_installdocs
	dh_installexamples
	dh_installinit -u 'start 45 S . stop 81 0 1 6 .' --no-start
	dh_installinit -u 'stop 80 0 1 6 .' --no-start --name=umountiscsi.sh
	dh_installman
	dh_link
	dh_strip
	dh_compress 
	dh_fixperms -Xetc/iscsi/iscsid.conf
	dh_makeshlibs
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb
# Build architecture independant packages using the common target.
binary-indep: build-indep install-indep
#	$(MAKE) -f debian/rules DH_OPTIONS=-i binary-common

# Build architecture dependant packages using the common target.
binary-arch: build-arch install-arch
	$(MAKE) -f debian/rules DH_OPTIONS=-a binary-common

binary: binary-arch binary-indep
.PHONY: build clean binary-indep binary-arch binary install install-indep install-arch configure get-orig-source

## open-iscsi 2.0.874

=== kernel/Makefile ===
#
# Makefile for the Linux Kernel iSCSI Initiator
#
# This Makefile invokes KBuild from outside the kernel directory when
# used from the main open-iscsi package. It also contains all of the
# KBuild stuff needed to build the modules.
#

# Kbuild stuff, the following is the only part of this file that KBuild
# actually uses itself.
EXTRA_CFLAGS += -I$(obj) -I$(obj)/../include 

ifeq ($(DEBUG_SCSI), 1)
EXTRA_CFLAGS += -DDEBUG_SCSI=1
endif

ifeq ($(DEBUG_TCP), 1)
EXTRA_CFLAGS += -DDEBUG_TCP=1
endif

obj-m				+= scsi_transport_iscsi.o
obj-m				+= libiscsi.o
obj-m				+= libiscsi_tcp.o
obj-m				+= iscsi_tcp.o

# Everything beyond this point is used to call KBuild or handle support
# for multiple kernel versions.

# Kbuild verbosity
V ?= 0

# allow users to override these
# eg to compile for a kernel that you aren't currently running
KERNELRELEASE ?= $(shell uname -r)
KSRC ?= /lib/modules/$(KERNELRELEASE)/build
KBUILD_OUTPUT ?= 
# this is the basic Kbuild invocation, just append your make target
KBUILD_BASE = +$(MAKE) -C $(KSRC) M=`pwd` KBUILD_OUTPUT=$(KBUILD_OUTPUT) $(KARCH) V=$(V)

all: kernel_check
	$(KBUILD_BASE) modules

# ============ BEGIN code for kernel_check and source patching ================
# We calculate the Linux version for compilation. Than according to version,
# if needed, we patch source-code to match the compiling kernel.
# if you need a new kernel sub-version just add a target below.
#
# IMPORTANT: do "make clean" before submitting to SVN so source is in unpatched
#            form.

#some constants
14to23_patch=2.6.14-23_compat.patch
24_patch=2.6.24_compat.patch
26_patch=2.6.26_compat.patch
27_patch=2.6.27_compat.patch
28to32_patch=2.6.28-32_compat.patch
33to34_patch=2.6.33-34_compat.patch
all_patches=14to21_patch 20to21_patch 24_patch 26_patch 27_patch 28to32_patch 33to34_patch
cur_patched=cur_patched

## fun stuff for maintaining multiple versions

# check to see if code is unpatched 
unpatch_code=$(shell test -e $(cur_patched) && echo do_unpatch_code )

KSUBLEVEL = $(shell cat $(KSRC)/Makefile | awk -F= '/^SUBLEVEL =/ {print $$2}' | \
		sed 's/^[ \t]*//;s/[ \t]*$$//')


KERNEL_TARGET=linux_2_6_$(KSUBLEVEL)
kernel_check: $(KERNEL_TARGET)

linux_2_6_14: has_14to23_patch

linux_2_6_15: has_14to23_patch

linux_2_6_16: has_14to23_patch

linux_2_6_17: has_14to23_patch

linux_2_6_18: has_14to23_patch

linux_2_6_19: has_14to23_patch

linux_2_6_20: has_14to23_patch

linux_2_6_21: has_14to23_patch

linux_2_6_22: has_14to23_patch

linux_2_6_23: has_14to23_patch

linux_2_6_24: has_24_patch

linux_2_6_25: has_24_patch

linux_2_6_26: has_26_patch

linux_2_6_27: has_27_patch

linux_2_6_28: has_28to32_patch

linux_2_6_29: has_28to32_patch

linux_2_6_30: has_28to32_patch

linux_2_6_31: has_28to32_patch

linux_2_6_32: has_28to32_patch

linux_2_6_33: has_33to34_patch

linux_2_6_34: has_33to34_patch

linux_2_6_35: $(unpatch_code)

do_unpatch_code:
	echo "Un-patching source code for use with linux-2.6.14 and up ..."
	patch -R -E -p1 < $(cur_patched)
	rm -f `readlink $(cur_patched)`
	rm -f $(cur_patched)

# these below targets must be the same as the variable name prefixed by has_
# otherwise below compat_patch: target will not work
has_14to23_patch: $(14to23_patch)
	echo "Patching source code for linux-2.6.14-23 ..."
	if [ -e $(cur_patched) ]; then \
		make -C . clean; \
	fi
	patch -p1 < $(14to23_patch)
	cp $(14to23_patch) $@
	ln -s $@ $(cur_patched)

has_24_patch: $(24_patch)
	echo "Patching source code for linux-2.6.24-25 ..."
	if [ -e $(cur_patched) ]; then \
		make -C . clean; \
	fi
	patch -p1 < $(24_patch)
	cp $(24_patch) $@
	ln -s $@ $(cur_patched)

has_26_patch: $(26_patch)
	echo "Patching source code for linux-2.6.26 ..."
	if [ -e $(cur_patched) ]; then \
		make -C . clean; \
	fi
	patch -p1 < $(26_patch)
	cp $(26_patch) $@
	ln -s $@ $(cur_patched)

has_27_patch: $(27_patch)
	echo "Patching source code for linux-2.6.27 ..."
	if [ -e $(cur_patched) ]; then \
		make -C . clean; \
	fi
	patch -p1 < $(27_patch)
	cp $(27_patch) $@
	ln -s $@ $(cur_patched)

has_28to32_patch: $(28to32_patch)
	echo "Patching source code for linux-2.6.28-33 ..."
	if [ -e $(cur_patched) ]; then \
		make -C . clean; \
	fi
	patch -p1 < $(28to32_patch)
	cp $(28to32_patch) $@
	ln -s $@ $(cur_patched)

has_33to34_patch: $(33to34_patch)
	echo "Patching source code for linux-2.6.33-34 ..."
	if [ -e $(cur_patched) ]; then \
		make -C . clean; \
	fi
	patch -p1 < $(33to34_patch)
	cp $(33to34_patch) $@
	ln -s $@ $(cur_patched)


# ============ END code for kernel_check and source patching =================

clean: $(unpatch_code)
	$(KBUILD_BASE) clean
	rm -f Module.symvers

## The following compat_patch target is what we need to do to prepare a clean
# compat_patch set after new code is check-in to svn. To keep patches fuzzless.
# the new patches are written into .new files so svn diff of next file will
# not trip on them.
compat_patch: $(unpatch_code)
	test -z "$(svn diff|head)" || { \
		echo "please run make compat_patch after changse are submited to svn"; \
		exit 1; \
	}
	for the_patch in all_patches ; do \
		make -C . has_$(the_patch); \
		svn diff > ${!the_patch}.new; \
	done

# the following is only for convienience
# do not submit to Linus
# it's also called from the toplevel makefile

# INSTALL_MOD_DIR is set so that the drivers go into the correct location using Kbuild
# it defaults to 'extra' otherwise
INSTALL_MOD_DIR ?= kernel/drivers/scsi

# this allows packaging of modules
ifdef DESTDIR
INSTALL_MOD_PATH=$(DESTDIR)
else
INSTALL_MOD_PATH=
endif

# this evil rule ensures that the modules get build if you specify $(ko)
# as a dependency.
ko = $(patsubst %.o,%.ko,$(obj-m))
$(ko): all

# now the actual command
install_kernel: $(ko)
	$(KBUILD_BASE) modules_install INSTALL_MOD_DIR=$(INSTALL_MOD_DIR) INSTALL_MOD_PATH=$(INSTALL_MOD_PATH)

dpkg_divert:
	for module in $(ko) ; do \
		dpkg-divert --rename /lib/modules/$(KERNELRELEASE)/$(INSTALL_MOD_DIR)/$$module ; \
	done

# vim: ft=make tw=72 sw=4 ts=4:

=== utils/sysdeps/Makefile ===
# This Makefile will work only with GNU make.

CFLAGS ?= -O2 -fno-inline -g
CFLAGS += $(WARNFLAGS) -Wall -Wstrict-prototypes

SYSDEPS_OBJS=sysdeps.o

all: $(SYSDEPS_OBJS)

clean:
	rm -f *.o .depend

depend:
	gcc $(CFLAGS) -M `ls *.c` > .depend

-include .depend

=== debian/changelog ===
open-iscsi (2.0.874-5ubuntu2) bionic; urgency=medium

  * debian/tests:
     - tgt-boot-test: Use 'timeout' to force a 60m timeout of the boot test.
     - README-boot-test.md: document environment variables BOOT_TIMEOUT
       and _USE_KVM.

 -- Scott Moser <smoser@ubuntu.com>  Wed, 21 Feb 2018 13:19:17 -0500

open-iscsi (2.0.874-5ubuntu1) bionic; urgency=low

  * Merge with Debian unstable. Remaining changes:
    - debian/tests: Add Ubuntu autopkgtests.
    - debian/iscsi-network-interface.rules, debian/net-interface-handler,
      debian/open-iscsi.install:
      Prevent network interface that contains iscsi root from bouncing
      during boot or going down during shutdown.
      Integrates with resolvconf and initramfs code that writes
      /run/initramfs/open-iscsi.interface
    - debian/open-iscsi.maintscript: clean up the obsolete
      iscsi-network-interface upstart job, file on upgrade.
    - Let iscsid systemd job run in privileged containers but not in
      unprivileged ones
    - Start open-iscsi systemd job when either /etc/iscsi/nodes or
      /sys/class/iscsi_session have content
      Based on patch by Nish Aravamudan, thanks! (LP #1576341)
    - add IPv6 support
      + add support for IPV6{DOMAINSEARCH,DNS0,DNS1} to net-interface-handler
        LP #1621507
      + Source /run/net6-*.conf when needed.
      + debian/extra/initramfs.local-top: handle IPv6 configs being
        shipped in DEVICE6 or /run/net6-*.conf in the initramfs, so we
        can fill in /run/initramfs/open-iscsi.interface (LP #1621507)

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Fri, 12 Jan 2018 14:00:59 +0000

open-iscsi (2.0.874-5) unstable; urgency=high

  * [aeb86f7] Fix multiple security issues in iscsiuio. (CVE-2017-17840)
    (Closes: #885021)

 -- Christian Seiler <christian@iwakd.de>  Sat, 23 Dec 2017 11:30:44 +0100

open-iscsi (2.0.874-4ubuntu5) bionic; urgency=medium

  * debian/tests/patch-image: mount auxilary filesystems before upgrading
    packages. Fixes ADT tests, when triggered by packages, that need
    /proc, /dev, etc mounted to complete the upgrade.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Wed, 03 Jan 2018 12:21:05 +0000

open-iscsi (2.0.874-4ubuntu4) bionic; urgency=medium

  * debian/tests/test-open-iscsi.py: skip test if cloud image is unavailable.
    This solves flaky tests in restricted network environments as well as in
    the short period after opening a new release (LP: #1731907).

 -- Christian Ehrhardt <christian.ehrhardt@canonical.com>  Thu, 16 Nov 2017 12:06:34 +0100

open-iscsi (2.0.874-4ubuntu3) artful; urgency=medium

  * debian/tests/xkvm: do not use kvm (-enable-kvm) by default if
    operating inside a vm.  nested kvm is finicky.

 -- Scott Moser <smoser@ubuntu.com>  Wed, 11 Oct 2017 18:14:08 -0400

open-iscsi (2.0.874-4ubuntu2) artful; urgency=medium

  * debian/tests/test-open-iscsi.py: query systemd-resolved if present.
    Ubuntu images now have systemd-resolved managing /etc/resolv.conf
    so support test if that is the case (LP: #1715468).

 -- Scott Moser <smoser@ubuntu.com>  Wed, 06 Sep 2017 16:20:16 -0400

open-iscsi (2.0.874-4ubuntu1) artful; urgency=medium

  * Merge with Debian unstable. Remaining changes:
    - debian/tests: Add Ubuntu autopkgtests.
    - debian/iscsi-network-interface.rules, debian/net-interface-handler,
      debian/open-iscsi.install:
      Prevent network interface that contains iscsi root from bouncing
      during boot or going down during shutdown.
      Integrates with resolvconf and initramfs code that writes
      /run/initramfs/open-iscsi.interface
    - debian/open-iscsi.maintscript: clean up the obsolete
      iscsi-network-interface upstart job, file on upgrade.
    - Let iscsid systemd job run in privileged containers but not in
      unprivileged ones
    - Start open-iscsi systemd job when either /etc/iscsi/nodes or
      /sys/class/iscsi_session have content
      Based on patch by Nish Aravamudan, thanks! (LP #1576341)
    - add IPv6 support
      + add support for IPV6{DOMAINSEARCH,DNS0,DNS1} to net-interface-handler
        LP #1621507
      + Source /run/net6-*.conf when needed.
      + debian/extra/initramfs.local-top: handle IPv6 configs being
        shipped in DEVICE6 or /run/net6-*.conf in the initramfs, so we
        can fill in /run/initramfs/open-iscsi.interface (LP #1621507)
  * Drop:
    - d/extra/initramfs.local-top: When booting from iBFT,
      set the PROTO= entry in /run/net-*.conf accordingly,
      so that other tools, such as cloud-init, can use that
      information. (cloud-init fails if the current PROTO=none
      is used.) (LP: #1684039) (Closes: #866213)
      [ Fixed in Debian 2.0.874-4 ]
  * d/t/test-open-iscsi.py: drop test_daemon test
    - With the updates to the systemd units, the services do not run
      unless iSCSI is configured.

 -- Nishanth Aravamudan <nish.aravamudan@canonical.com>  Tue, 08 Aug 2017 16:16:27 -0700

open-iscsi (2.0.874-4) unstable; urgency=medium

  * [0347300] initramfs: populate PROTO= entry in /run/net-*.conf from iBFT
    (Closes: #866213)

 -- Christian Seiler <christian@iwakd.de>  Sun, 02 Jul 2017 18:01:09 +0200

open-iscsi (2.0.874-3) unstable; urgency=medium

  * [e506ea0] udeb: don't update initramfs when iSCSI is not used.
    (Closes: #863435)

 -- Christian Seiler <christian@iwakd.de>  Sun, 18 Jun 2017 22:01:22 +0200

open-iscsi (2.0.874-2ubuntu3) artful; urgency=medium

  * d/t/test-open-iscsi.py: drop test_daemon test
    - With the updates to the systemd units, the services do not run
      unless iSCSI is configured.

 -- Nishanth Aravamudan <nish.aravamudan@canonical.com>  Tue, 08 Aug 2017 16:05:29 -0700

open-iscsi (2.0.874-2ubuntu2) artful; urgency=medium

  * d/extra/initramfs.local-top: When booting from iBFT,
    set the PROTO= entry in /run/net-*.conf accordingly,
    so that other tools, such as cloud-init, can use that
    information. (cloud-init fails if the current PROTO=none


=== debian/control ===
Source: open-iscsi
Section: net
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian iSCSI Maintainers <pkg-iscsi-maintainers@lists.alioth.debian.org>
Uploaders: Ritesh Raj Sarraf <rrs@debian.org>,
           Christian Seiler <christian@iwakd.de>
Build-Depends: autotools-dev,
               bison,
               bzip2,
               debhelper (>= 9),
               dh-autoreconf,
               dh-exec,
               dh-systemd,
               dpkg-dev (>= 1.16.1~),
               flex,
               libisns-dev (>= 0.96-4~),
               libmount-dev,
               po-debconf
Standards-Version: 3.9.8
Vcs-Git: https://anonscm.debian.org/git/pkg-iscsi/open-iscsi.git
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-iscsi/open-iscsi.git
Homepage: http://www.open-iscsi.com/
Testsuite: autopkgtest

Package: open-iscsi
Architecture: linux-any
Depends: udev, ${misc:Depends}, ${shlibs:Depends}, lsb-base (>= 3.0-6)
Recommends: ${busybox:Recommends}
Pre-Depends: debconf | debconf-2.0
Description: iSCSI initiator tools
 Open-iSCSI is a high-performance, transport independent, multi-platform
 implementation of the RFC3720 Internet Small Computer Systems Interface
 (iSCSI).
 .
 Open-iSCSI is partitioned into user and kernel parts, where the kernel
 portion implements the iSCSI data path (i.e. iSCSI Read and iSCSI Write).
 The userspace contains the entire control plane:
  * Configuration Manager;
  * iSCSI Discovery;
  * Login and Logout processing;
  * Connection level error processing;
  * Nop-In and Nop-Out handling;
  * (in the future) Text processing, iSNS, SLP, Radius, etc.
 .
 This package includes a daemon, iscsid, and a management utility,
 iscsiadm.

Package: iscsiuio
Architecture: linux-any
Depends: udev, ${misc:Depends}, ${shlibs:Depends}
Enhances: open-iscsi
Description: iSCSI offloading daemon for QLogic devices
 Open-iSCSI is a high-performance, transport independent, multi-platform
 implementation of the RFC3720 Internet Small Computer Systems Interface
 (iSCSI).
 .
 This package contains the userspace offloading daemon, for use with
 QLogic (formerly Broadcom) NetXtreme II hardware, as supported by the
 'bnx2' and 'bnx2x' drivers, in conjunction with the 'bnx2i' driver.
 .
 The following network controllers are supported:
  bnx2:  BCM5706, BCM5708, BCM5709 devices
  bnx2x: BCM57710, BCM57711, BCM57711E, BCM57712, BCM57712E, BCM57800,
         BCM57810, BCM57840
 .
 This package is required to offload iSCSI onto these devices.

Package: open-iscsi-udeb
# Note: the (virtual) udeb package scsi-modules (provided by different
#       linux kernel udebs) must exist for these architectures - so
#       check that before adding them to this list; the other
#       scsi-(core|common|...)-modules are NOT sufficient!
Architecture: amd64 arm64 armhf i386 ia64 mips mipsel powerpc ppc64 ppc64el s390x
Section: debian-installer
Package-Type: udeb
Depends: scsi-modules, ${misc:Depends}, ${shlibs:Depends}
Description: Configure iSCSI
 Open-iSCSI is a high-performance, transport independent, multi-platform
 implementation of the RFC3720 Internet Small Computer Systems Interface
 (iSCSI).
 .
 This is the minimal package (udeb) used by debian-installer.

=== debian/rules ===
#!/usr/bin/make -f
# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND = -Wall -DOFFLOAD_BOOT_SUPPORTED

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk

%:
	dh $@ --with autotools_dev,autoreconf,systemd

DEB_UPSTREAM_VERSION := $(shell dpkg-parsechangelog | sed -rne 's,^Version: ([^-]+).*,\1,p')

get-orig-source:
	uscan --force-download --rename --repack --download-version=$(DEB_UPSTREAM_VERSION) --destdir=.

override_dh_auto_build:
	@# We want to regenerate the parser/lexer files with bison/flex
	@# to make sure that the package is fully built from source.
	@# Store the generated files upstream added to the source
	@# tarball away and explicitly call flex/bison here.
	mv utils/fwparam_ibft/prom_lex.c       utils/fwparam_ibft/prom_lex.c.upstream
	mv utils/fwparam_ibft/prom_parse.tab.c utils/fwparam_ibft/prom_parse.tab.c.upstream
	mv utils/fwparam_ibft/prom_parse.tab.h utils/fwparam_ibft/prom_parse.tab.h.upstream
	cd utils/fwparam_ibft && flex -t prom_lex.l | \
		../../debian/workaround_flex_bug.sh > prom_lex.c
	cd utils/fwparam_ibft && bison -d prom_parse.y

	@# The build system doesn't support CPPFLAGS
	env CFLAGS="$(CPPFLAGS) $(CFLAGS)" dh_auto_build
	@# Build udeb variant without libmount
	mkdir -p build.deb
	cp -a usr/iscsid usr/iscsistart build.deb/
	rm usr/initiator_common.o usr/mntcheck.o usr/iscsid usr/iscsistart
	env CFLAGS="$(CPPFLAGS) $(CFLAGS) -DNO_LIBMOUNT" dh_auto_build -- LIBMOUNT_LIB=

override_dh_auto_install:
	@# do nothing, we install stuff with dh_install etc.

override_dh_auto_clean:
	dh_auto_clean
	rm -rf build.deb
	@# Make dpkg-source happy and restore upstream's generated lexer/parser files
	@# in the clean step.
	! [ -f utils/fwparam_ibft/prom_lex.c.upstream ]       || mv utils/fwparam_ibft/prom_lex.c.upstream       utils/fwparam_ibft/prom_lex.c
	! [ -f utils/fwparam_ibft/prom_parse.tab.c.upstream ] || mv utils/fwparam_ibft/prom_parse.tab.c.upstream utils/fwparam_ibft/prom_parse.tab.c
	! [ -f utils/fwparam_ibft/prom_parse.tab.h.upstream ] || mv utils/fwparam_ibft/prom_parse.tab.h.upstream utils/fwparam_ibft/prom_parse.tab.h

override_dh_fixperms:
	dh_fixperms
	@# That configuration file might contain authentication data, so
	@# don't make it world-readable. See bug #735773 for details.
	chmod 0600 $(CURDIR)/debian/open-iscsi/etc/iscsi/iscsid.conf
	@# Since this file is copied from the installer ramdisk to the
	@# system if the udeb is used, the permissions need to be changed
	@# here as well.
	@# However, we might be building on an architecture that doesn't
	@# have udeb support yet (see debian/control), so see if it was
	@# installed during build before trying to adjust permissions.
	if [ -f $(CURDIR)/debian/open-iscsi-udeb/etc/iscsi/iscsid.conf ] ; then \
		chmod 0600 $(CURDIR)/debian/open-iscsi-udeb/etc/iscsi/iscsid.conf ; \
	fi

override_dh_installchangelogs:
	dh_installchangelogs -piscsiuio iscsiuio/ChangeLog
	dh_installchangelogs --remaining-packages

override_dh_installinit:
	dh_installinit -popen-iscsi --no-start --name=iscsid
	dh_installinit -popen-iscsi --no-start
	dh_installinit --remaining-packages

override_dh_systemd_enable:
	dh_systemd_enable -popen-iscsi --name=iscsid
	dh_systemd_enable -popen-iscsi
	dh_systemd_enable --remaining-packages

override_dh_systemd_start:
	dh_systemd_start -popen-iscsi --no-restart-on-upgrade --no-start iscsid.service open-iscsi.service
	dh_systemd_start --remaining-packages

# The following is taken from the initramfs-tools package. (We recommend
# busybox in the initramfs because otherwise we don't have access to the
# ip utility to set the default gateway after iscsistart -N is done.)
# On Debian we can use either busybox or busybox-static, but on Ubuntu
# and derivatives only busybox-initramfs will work.
BUSYBOX_PACKAGES := $(shell if dpkg-vendor --derives-from ubuntu; then echo busybox-initramfs; else echo busybox busybox-static; fi)

override_dh_gencontrol:
	echo >> debian/open-iscsi.substvars "busybox:Recommends=$(wordlist 2,100,$(BUSYBOX_PACKAGES:%=| %))"
	dh_gencontrol

=== debian/tests/control ===
Tests: install
Restrictions: needs-root isolation-machine breaks-testbed
Depends:

Tests: testsuite
Restrictions: needs-root isolation-machine breaks-testbed
Depends: open-iscsi, python, tgt, qemu-system, ubuntu-cloudimage-keyring, simplestreams, python-netifaces, distro-info, cloud-image-utils, dctrl-tools, rsync

Tests: nested
Restrictions: needs-root, isolation-machine, breaks-testbed, allow-stderr
Depends: targetcli-fb, autopkgtest (>= 4~), qemu-system, qemu-utils, python3, python3-netifaces
